# Huawei Cloud DIS SDK for Node.js 


数据接入服务(DIS)在 [DIS Homepage](https://www.huaweicloud.com/en-us/product/dis.html), 或中文页面 [数据接入服务](https://www.huaweicloud.com/product/dis.html)

安装
------------

- 快速安装:

```shell
$ npm install dis-sdk-nodejs
```

- 源代码安装, 把dis-sdk-nodejs安装至全局npm包目录, 以windows为例:

1. 从[DIS-SDK](https://dis-publish.obs-website.cn-north-1.myhwclouds.com/)下载`huaweicloud-sdk-dis-nodejs-1.0.0.zip`
2. 解压`huaweicloud-sdk-dis-nodejs-1.0.0.zip`, 进入`huaweicloud-sdk-dis-nodejs-1.0.0`目录后执行`npm install` 
3. 在cmd中执行`npm config list`, 找到prefix的路径, 本例中prefix路径为`D:\installation\node\prefix`
4. 将`huaweicloud-sdk-dis-nodejs-1.0.0`目录重命名为`dis-sdk-nodejs`, 然后将`dis-sdk-nodejs`目录整体复制到prefix路径下的node_modules目录内, 本例中是把dis-sdk-nodejs目录复制到`D:\installation\node\prefix\node_modules\`下


Node.js 版本
-------------------

已在 Node.js v10.15.3 测试验证通过

Usage
-----

```javascript
var DISClientBuilder = require('dis-sdk-nodejs');
var RecordsStub = require('./stub/Records'); 

var CONF = {
  PROJECTID: '43e2c9ac4e8b4c6d9d751a2c8a230a8c',
  REGIONNAME: 'cn-north-7',
  AK: 'YOUR_AK',
  SK: 'YOUR_SK'
};

process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';

var STREAM_NAME = 'fangzhirui11';

var api = DISClientBuilder.buildRecordApi(CONF);
var putRecordsRequest = RecordsStub.mockPutRecordsRequest(STREAM_NAME);
api.putRecords(CONF.PROJECTID, JSON.stringify(putRecordsRequest), function (error, data) {
  console.log(error);
  console.log(data);
});
```

支持API
-----------
1. putRecords (上传消息), getRecords (下载消息)
2. getCheckpoint (获取检查点), commitCheckpoint (创建检查点), deleteCheckpoint (删除检查点)
3. getCursor (获取游标)

示例
-----------

1. 上传消息
```shell
cd dis-sdk-nodejs
node putRecordsDemo.js
```

2. 下载消息
```shell
cd dis-sdk-nodejs
node getRecordsDemo.js
```

