var DISClientBuilder = require('./src/index');
var RecordsStub = require('./src/stub/Records');

var CONF = {
  PROJECTID: '43e2c9ac4e8b4c6d9d751a2c8a230a8c',
  REGIONNAME: 'cn-north-7',
  AK: 'YOUR_AK',
  SK: 'YOUR_SK'
};

process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';

var STREAM_NAME = 'fangzhirui11';

var api = DISClientBuilder.buildRecordApi(CONF);
var putRecordsRequest = RecordsStub.mockPutRecordsRequest(STREAM_NAME);

var partitionId = 'shardId-0000000000';


/*
  Get cursor by cursorType = 'AT_SEQUENCE_NUMBER' & startingSequenceNumber
*/
api.getCursor(CONF.PROJECTID, STREAM_NAME, partitionId, {
  cursorType: 'AT_SEQUENCE_NUMBER',
  startingSequenceNumber: '420'
}, function (error, data, response) {
  if (error) {
    console.error('error => ' + error);
    console.error("error details => " + response.text);
    console.error("http code => " + response.status);
  } else {
    console.log("data => " + JSON.stringify(data));
    console.log("response text => " + response.text);
  }
});

/*
  Get cursor by cursorType = 'AT_TIMESTAMP' & timestamp
*/
api.getCursor(CONF.PROJECTID, STREAM_NAME, partitionId, {
  cursorType: 'AT_TIMESTAMP',
  timestamp: new Date().getTime()
}, function (error, data, response) {
  if (error) {
    console.error('error => ' + error);
    console.error("error details => " + response.text);
    console.error("http code => " + response.status);
  } else {
    console.log("data => " + JSON.stringify(data));
    console.log("response text => " + response.text);
  }
});
